
Installer - Bug #19713

Upgrade of Foreman cannot handle renamed smart-proxies

05/30/2017 04:32 PM - Josh Pavel

Status: New   

Priority: Normal   

Assignee:    

Category: Foreman modules   

Target version:    

Difficulty:  Fixed in Releases:  

Triaged: Yes Found in Releases: 1.5.0

Bugzilla link:  Red Hat JIRA:  

Pull request:    

Description

To reproduce:

1.) Rename your smart-proxy to something that doesn't match the FQDN

2.) Perform an upgrade of Foreman or Foreman/Katello

3.) The installer will fail with something like this:

Proxy foreman-01.prod.mcs.som.mob.nuance.com cannot be registered: URL Only one declaration of a p

roxy is allowed

/usr/share/foreman-installer/modules/foreman/lib/puppet/provider/foreman_smartproxy/rest_v3.rb:23:

in `create'

/opt/puppetlabs/puppet/lib/ruby/vendor_ruby/puppet/property/ensure.rb:16:in `block in defaultvalue

s'

/opt/puppetlabs/puppet/lib/ruby/vendor_ruby/puppet/property.rb:487:in `set'

/opt/puppetlabs/puppet/lib/ruby/vendor_ruby/puppet/property.rb:561:in `sync'

/opt/puppetlabs/puppet/lib/ruby/vendor_ruby/puppet/transaction/resource_harness.rb:236:in `sync'

/opt/puppetlabs/puppet/lib/ruby/vendor_ruby/puppet/transaction/resource_harness.rb:134:in `sync_if

_needed'

/opt/puppetlabs/puppet/lib/ruby/vendor_ruby/puppet/transaction/resource_harness.rb:80:in `perform_

changes'

/opt/puppetlabs/puppet/lib/ruby/vendor_ruby/puppet/transaction/resource_harness.rb:21:in `evaluate

'

/opt/puppetlabs/puppet/lib/ruby/vendor_ruby/puppet/transaction.rb:230:in `apply'

/opt/puppetlabs/puppet/lib/ruby/vendor_ruby/puppet/transaction.rb:246:in `eval_resource'

/opt/puppetlabs/puppet/lib/ruby/vendor_ruby/puppet/transaction.rb:163:in `call'

/opt/puppetlabs/puppet/lib/ruby/vendor_ruby/puppet/transaction.rb:163:in `block (2 levels) in eval

uate'

/opt/puppetlabs/puppet/lib/ruby/vendor_ruby/puppet/util.rb:387:in `block in thinmark'

/opt/puppetlabs/puppet/lib/ruby/2.1.0/benchmark.rb:294:in `realtime'

/opt/puppetlabs/puppet/lib/ruby/vendor_ruby/puppet/util.rb:386:in `thinmark'

/opt/puppetlabs/puppet/lib/ruby/vendor_ruby/puppet/transaction.rb:163:in `block in evaluate'

/opt/puppetlabs/puppet/lib/ruby/vendor_ruby/puppet/graph/relationship_graph.rb:118:in `traverse'

/opt/puppetlabs/puppet/lib/ruby/vendor_ruby/puppet/transaction.rb:154:in `evaluate'

/usr/share/gems/gems/kafo-2.0.0/modules/kafo_configure/lib/puppet/parser/functions/add_progress.rb

:30:in `evaluate_with_trigger'

/opt/puppetlabs/puppet/lib/ruby/vendor_ruby/puppet/resource/catalog.rb:222:in `block in apply'

/opt/puppetlabs/puppet/lib/ruby/vendor_ruby/puppet/util/log.rb:155:in `with_destination'

/opt/puppetlabs/puppet/lib/ruby/vendor_ruby/puppet/transaction/report.rb:142:in `as_logging_destin

ation'

/opt/puppetlabs/puppet/lib/ruby/vendor_ruby/puppet/resource/catalog.rb:221:in `apply'

/opt/puppetlabs/puppet/lib/ruby/vendor_ruby/puppet/configurer.rb:171:in `block in apply_catalog'

/opt/puppetlabs/puppet/lib/ruby/vendor_ruby/puppet/util.rb:224:in `block in benchmark'

/opt/puppetlabs/puppet/lib/ruby/2.1.0/benchmark.rb:294:in `realtime'

/opt/puppetlabs/puppet/lib/ruby/vendor_ruby/puppet/util.rb:223:in `benchmark'

/opt/puppetlabs/puppet/lib/ruby/vendor_ruby/puppet/configurer.rb:170:in `apply_catalog'

/opt/puppetlabs/puppet/lib/ruby/vendor_ruby/puppet/configurer.rb:343:in `run_internal'

/opt/puppetlabs/puppet/lib/ruby/vendor_ruby/puppet/configurer.rb:221:in `block in run'
/opt/puppetlabs/puppet/lib/ruby/vendor_ruby/puppet/context.rb:65:in `override'

/opt/puppetlabs/puppet/lib/ruby/vendor_ruby/puppet.rb:294:in `override'

/opt/puppetlabs/puppet/lib/ruby/vendor_ruby/puppet/configurer.rb:195:in `run'

/opt/puppetlabs/puppet/lib/ruby/vendor_ruby/puppet/application/apply.rb:350:in `apply_catalog'

/opt/puppetlabs/puppet/lib/ruby/vendor_ruby/puppet/application/apply.rb:274:in `block in main'

/opt/puppetlabs/puppet/lib/ruby/vendor_ruby/puppet/context.rb:65:in `override'

/opt/puppetlabs/puppet/lib/ruby/vendor_ruby/puppet.rb:294:in `override'

/opt/puppetlabs/puppet/lib/ruby/vendor_ruby/puppet/application/apply.rb:225:in `main'

/opt/puppetlabs/puppet/lib/ruby/vendor_ruby/puppet/application/apply.rb:170:in `run_command'

/opt/puppetlabs/puppet/lib/ruby/vendor_ruby/puppet/application.rb:358:in `block in run'

/opt/puppetlabs/puppet/lib/ruby/vendor_ruby/puppet/util.rb:542:in `exit_on_fail'

/opt/puppetlabs/puppet/lib/ruby/vendor_ruby/puppet/application.rb:358:in `run'

/opt/puppetlabs/puppet/lib/ruby/vendor_ruby/puppet/util/command_line.rb:132:in `run'

/opt/puppetlabs/puppet/lib/ruby/vendor_ruby/puppet/util/command_line.rb:72:in `execute'

/opt/puppetlabs/puppet/bin/puppet:5:in `&lt;main&gt;'

 /Stage[main]/Foreman_proxy::Register/Foreman_smartproxy[foreman-01.prod.mcs.som.mob.nuance.com]/e

nsure: change from absent to present failed: Proxy foreman-01.prod.mcs.som.mob.nuance.com cannot b

e registered: URL Only one declaration of a proxy is allowed

 To successfully get past this step, you can rename the smart-proxy to match the FQDN and re-run the installer.

Expected behavior: Smart-proxies should be recognized by the upgrade even if they have been renamed.

History

#1 - 05/31/2017 03:07 AM - Dominic Cleal

- Project changed from Foreman to Installer

- Category changed from Packaging to Foreman modules

#2 - 10/27/2018 01:49 AM - Paul Calabro

- Found in Releases 1.9.0 added

- Found in Releases deleted (1.15.0)

Just came around this error. The suggested fix by the user resolved the issue.

EDIT: Sorry the version automatically changed to 1.9.0 in the form. Just reverted the change back to its original value.

#3 - 10/27/2018 01:50 AM - Paul Calabro

- Found in Releases 1.5.0 added

- Found in Releases deleted (1.9.0)

#4 - 04/23/2020 01:39 PM - Zach Huntington-Meath

- Triaged changed from No to Yes
